﻿/*	Zone ruler creator © 2012 by Russell Cottrell
	Please visit russellcottrell.com			*/



#target photoshop

app.bringToFront();

if (app.documents.length < 2)
	alert("Please open at least two documents.");

else {

var strtRulerUnits = app.preferences.rulerUnits;
app.preferences.rulerUnits = Units.PIXELS;






var iniFile = new File("ZoneRuler.ini");
iniFile.open("r");
var squareSize = Math.abs(parseInt(iniFile.readln()));
iniFile.close();

squareSize = (isFinite(squareSize)) ? squareSize : 170;

squareSize = Math.abs(parseInt(Window.prompt("ruler unit square size, pixels:", squareSize, "Zone Ruler")));

if (isFinite(squareSize)) { // do it //

iniFile.open("w");
iniFile.writeln(squareSize);	// saves entry as the default square size
iniFile.close();

var docRef, newDocRef, hs, pChannel, LSum, i, k, xx, yy, sRegion, t;



var docArray = new Array();
for (k=0; k<app.documents.length; k++) {
	docArray[k] = new Array();
	docArray[k]["img"] = app.documents[k];

	docRef = docArray[k]["img"];
	app.activeDocument = docRef;

	docArray[k]["w"] = parseInt(docRef.width);
	docArray[k]["h"] = parseInt(docRef.height);

	hs = 0;
	if (docRef.bitsPerChannel != BitsPerChannelType.SIXTEEN) {
		docRef.bitsPerChannel = BitsPerChannelType.SIXTEEN;
		hs++; }
	if (docRef.mode != DocumentMode.LAB) {
		docRef.changeMode(ChangeMode.LAB);
		hs++; }

	pChannel = docRef.channels["Lightness"].histogram;
	LSum = 0;
	for (i = 0; i <= 255; i++)
		LSum += i * pChannel[i];
	docArray[k]["LMean"] = LSum / (docArray[k]["w"] * docArray[k]["h"]);

	docRef.activeHistoryState =
		docRef.historyStates[docRef.historyStates.length - hs - 1]; }



docArray = docArray.sort(function(a, b) {

var aMean = a["LMean"];
var bMean = b["LMean"];
if (aMean < bMean)
	return -1;
else if (aMean > bMean)
	return 1;
else	return 0;

} );






newDocRef = app.documents.add(squareSize * docArray.length, squareSize, 72,
	"Zone Ruler", NewDocumentMode.RGB);	// gotta be 72 for translate to work
newDocRef.bitsPerChannel = BitsPerChannelType.SIXTEEN;

for (k=0; k<docArray.length; k++) {

	docRef = docArray[k]["img"];
	app.activeDocument = docRef;

	xx = Math.floor((docArray[k]["w"] - squareSize) / 2);
	yy = Math.floor((docArray[k]["h"] - squareSize) / 2);

	sRegion = new Array(
		new Array(xx, yy),
		new Array(xx + squareSize, yy),
		new Array(xx + squareSize, yy + squareSize),
		new Array(xx, yy + squareSize));

	docRef.selection.select(sRegion, SelectionType.REPLACE, 0, false);
	docRef.selection.copy();
	docRef.activeHistoryState =
		docRef.historyStates[docRef.historyStates.length - 2];

	app.activeDocument = newDocRef;
	newDocRef.paste();
	t = -parseInt(newDocRef.activeLayer.bounds[0]) + (squareSize * k);
	newDocRef.activeLayer.translate(t, 0);

}



var marginH = Math.round(squareSize / 10);

var whiteColor = new SolidColor;
whiteColor.rgb.red = 255;
whiteColor.rgb.green = 255;
whiteColor.rgb.blue = 255;

var blackColor = new SolidColor;
blackColor.rgb.red = 0;
blackColor.rgb.green = 0;
blackColor.rgb.blue = 0;



newDocRef.resizeCanvas(newDocRef.width, newDocRef.height + marginH, AnchorPosition.BOTTOMCENTER);

sRegion = new Array(
	new Array(0, 0),
	new Array(newDocRef.width, 0),
	new Array(newDocRef.width, marginH),
	new Array(0, marginH));

newDocRef.selection.select(sRegion, SelectionType.REPLACE, 0, false);

newDocRef.selection.fill(whiteColor, ColorBlendMode.NORMAL, 100);

newDocRef.selection.deselect();



newDocRef.resizeCanvas(newDocRef.width, newDocRef.height + marginH, AnchorPosition.TOPCENTER);

sRegion = new Array(
	new Array(0, newDocRef.height - marginH),
	new Array(newDocRef.width, newDocRef.height - marginH),
	new Array(newDocRef.width, newDocRef.height),
	new Array(0, newDocRef.height));

newDocRef.selection.select(sRegion, SelectionType.REPLACE, 0, false);

newDocRef.selection.fill(blackColor, ColorBlendMode.NORMAL, 100);

newDocRef.selection.deselect();



newDocRef.resizeImage(newDocRef.width, newDocRef.height, 300);






} // do it //






app.preferences.rulerUnits = strtRulerUnits;

}